# 3D-Models

{% hint style="danger" %}
Do not reload the plugin or the server to put these changes into effect. Restart the server.
{% endhint %}

{% hint style="info" %}
You do not need to do this, if you want to use the default models. This is a way to add more alternatives with resource packs.
{% endhint %}

***

## <mark style="color:orange;">Enabling Custom 3D-Models</mark>

To enable this feature, you need to disable the following config option. This setting may not be in your config, as it has been added in Vehicles 14.2!

```yaml
nativeModelsEnabled: false
```

This setting will disable all default models, limiting them to one invisible armorstand.

***

## <mark style="color:orange;">Important Notices</mark>

* Using this feature will remove all default models, limiting them to a single invisible armorstand.
* You can add your own models made with resource packs. File uploads and other models are not supported.
* Seat positions remain unchanged, regardless of your added model.
* All features of the default vehicles remain the same. Only the look changes!

***

## <mark style="color:orange;">Adding the ItemStack</mark>

To swap the vehicle for your new model, add the following code to a vehicle config:

```yaml
3dModelItem:
  ==: org.bukkit.inventory.ItemStack
  type: <ITEM>
  v: <VERSION>
  amount: 1
  meta:
    ==: ItemMeta
    meta-type: UNSPECIFIC
    custom-model-data: 1
```

{% hint style="info" %}
Make sure to adjust the `v` (Version) value, to match your data version:\
\
<https://minecraft.wiki/w/Data_version>
{% endhint %}

{% hint style="info" %}
Want to use more ItemMeta? Check out the entire format and settings here:\
\
<https://www.spigotmc.org/wiki/itemstack-serialization/>
{% endhint %}

***

The following is an example setting for the black car. For the default config options, see [<mark style="color:orange;">here</mark>](/configuration/vehicle-settings.md).

```yaml
cars:
  'BLACK':
  mainMaterial: 'BLACK_TERRACOTTA'
  wheelsUrl: 'http://textures.minecraft.net/texture/444cd5d2fd2fe397ddb927e184f19ecbd0fe24af6ef68852c172ae447cd4'
  frontLightsUrl: 'http://textures.minecraft.net/texture/59e9c9246f1ba5a41e53efa68b2bd56a70da308f393487dcf6fe756799b3c7'
  backLightsUrl: 'http://textures.minecraft.net/texture/4636afc9ecb492722eda37eaab7f5c4acca8974bdc628e4273cbcebd45073ac'
  steelUrl: 'http://textures.minecraft.net/texture/f0d3c96f8c183cf9415c437e4972827656abe7bee36d81d1e9c04466514b9e4'
  maxSpeed: 1
  maxBackSpeed: 0.5
  acelerationValue: 0.006
  displayName: '&7Black Car'
  permission: 'Cars.type.BLACK'
  maxHealth: 40
  fuelCapacity: 1000
  fuelWasteSpeed: 1.2
  3dModelItem:
    ==: org.bukkit.inventory.ItemStack
    type: CARVED_PUMPKIN
    v: 3465
    amount: 1
    meta:
      ==: ItemMeta
      meta-type: UNSPECIFIC
      custom-model-data: 1
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.vehiclesplugin.com/configuration/3d-models.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
